/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel;

import org.zhiqim.kernel.constants.ZhiqimConstants;
import org.zhiqim.kernel.logging.Log;
import org.zhiqim.kernel.logging.LogFactory;

/**
 * 知启蒙工程退出锚，当Runtime捕捉到shutdown时会调用该锚，用于退出清理
 * 
 * @version v1.0.0 @author zouzhigang 2014-2-27 新建与整理
 */
final class ZhiqimHook extends Thread implements ZhiqimConstants
{
    private static final Log log = LogFactory.getLog(ZhiqimHook.class);
    
    public void run()
    {
        //1.退出开始日志
        log.info("系统[%s]-版本[%s]正在退出...", Global.getName(), Global.getVersion());
        
        //2.退出所有服务
        Global.removeServiceAll();

        //3.退出完成日志
        log.info("系统[%s]-版本[%s]退出完成...", Global.getName(), Global.getVersion());
    }
}