/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.control;

/**
 * 事件处理器，通过冒泡方式处理，以支持一个事件多个事件处理器顺序执行
 *
 * @version v1.0.0 @author zouzhigang 2014-3-21 新建与整理
 */
public interface Eventer<E>
{
    /**
     * 显性提供事件类接口，用于事件注册到控制器中
     * 
     * @return 返回事件类
     */
    public Class<E> clazz();
    
    /** 
     * 事件处理器接口 
     * 
     * @param event 事件
     * @return      返加处理状态，=true表示处理完成，向上冒泡，=false表示处理终止，停止冒泡
     */
    public boolean process(E event);
}
