/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.control;

import org.zhiqim.kernel.util.Validates;

/**
 * 根据EndsWith进行过滤
 *
 * @version v1.0.0 @author zouzhigang 2016-7-14 新建与整理
 */
public class FilterEndsWith implements Filter
{
    private String endsWith;
    
    @Override
    public Filter param(Object param)
    {
        this.endsWith = (String)param;
        return this;
    }
    
    @Override
    public boolean access(Object match)
    {
        String name = (String)match;
        return Validates.isEmpty(endsWith) || name.endsWith(endsWith);
    }
}
