/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.extend;

import java.util.ArrayList;
import java.util.Collection;

import org.zhiqim.kernel.annotation.AnAlias;
import org.zhiqim.kernel.annotation.AnNew;
import org.zhiqim.kernel.json.Jsons;

/**
 * 定义一个ArrayList<String>对象，在ZML中new时不需要指定泛型
 *
 * @version v1.0.0 @author zouzhigang 2016-10-25 新建与整理
 */
@AnAlias("ArrayListS")
@AnNew
public class ArrayListS extends ListS
{
    private final ArrayList<String> instance;
    
    public ArrayListS()
    {
        instance = new ArrayList<>();
    }
    
    public ArrayListS(int count)
    {
        instance = new ArrayList<>(count);
    }
    
    public ArrayListS(String s)
    {
        instance = new ArrayList<>(1);
        instance.add(s);
    }
    
    public ArrayListS(Collection<String> instance)
    {
        this.instance = new ArrayList<>(instance);
    }
    
    public ArrayListS(ListS instance)
    {
        this.instance = new ArrayList<>(instance.instance());
    }
    
    /***********************************************************/
    //实例化
    /***********************************************************/
    
    /**
     * 返回对应的List实例
     * 
     * @return          List实例
     */
    public ArrayList<String> instance()
    {
        return instance;
    }
    
    /***********************************************************/
    //私有方法
    /***********************************************************/
    
    public ArrayListS trimToSize() 
    {
        instance.trimToSize();
        return this;
    }

    public ArrayListS ensureCapacity(int minCapacity) 
    {
        instance.ensureCapacity(minCapacity);
        return this;
    }
    
    @Override
    public String toString()
    {
        return Jsons.toString(instance);
    }
}
