/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.extend;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.zhiqim.kernel.annotation.AnAlias;
import org.zhiqim.kernel.annotation.AnNew;

/**
 * 定义一个HashMap<String, Class<?>>参数和结果对象，但不要求<K, V>，比Map在ZML中new时不需要指定泛型
 *
 * @version v1.0.0 @author zouzhigang 2016-10-25 新建与整理
 */
@AnAlias("HashMapSC")
@AnNew
public class HashMapSC extends MapSC
{
    /****************************************************************************************************/
    //HashMap
    /****************************************************************************************************/
    
    public HashMapSC()
    {
        this(false);
    }
    
    public HashMapSC(int count)
    {
        this(count, false);
    }
    
    public HashMapSC(String key, Class<?> value)
    {
        this(key, value, false);
    }
    
    public HashMapSC(Map<String, Class<?>> instance)
    {
        this(instance, false);
    }
    
    public HashMapSC(MapSC map)
    {
        this(map, false);
    }
    
    /****************************************************************************************************/
    //ConcurrentHashMap
    /****************************************************************************************************/
    
    public HashMapSC(boolean concurrent)
    {
        if (concurrent)
            instance = new ConcurrentHashMap<>();
        else
            instance = new HashMap<>();
    }
    
    public HashMapSC(int count, boolean concurrent)
    {
        if (concurrent)
            instance = new ConcurrentHashMap<>(count);
        else
            instance = new HashMap<>(count);
    }
    
    public HashMapSC(String key, Class<?> value, boolean concurrent)
    {
        this(concurrent);
        instance.put(key, value);
    }
    
    public HashMapSC(Map<String, Class<?>> instance, boolean concurrent)
    {
        if (concurrent)
            instance = new ConcurrentHashMap<>(instance);
        else
            instance = new HashMap<>(instance);
    }
    
    public HashMapSC(MapSC map, boolean concurrent)
    {
        this(map.instance(), concurrent);
    }
}
