/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.extend;

import java.util.Collection;
import java.util.HashSet;

import org.zhiqim.kernel.annotation.AnAlias;
import org.zhiqim.kernel.annotation.AnNew;

/**
 * 定义一个HashSet<Object>对象，在ZML中new时不需要指定泛型
 *
 * @version v1.0.0 @author zouzhigang 2016-10-25 新建与整理
 */
@AnAlias("HashSetO")
@AnNew
public class HashSetO extends HashSetV<Object>
{
    public HashSetO()
    {
        instance = new HashSet<>();
    }
    
    public HashSetO(int count)
    {
        instance = new HashSet<>(count);
    }
    
    public HashSetO(Object s)
    {
        instance = new HashSet<>(1);
        instance.add(s);
    }
    
    public HashSetO(Collection<?> instance)
    {
        this.instance = new HashSet<>(instance);
    }
    
    public HashSetO(HashSetO instance)
    {
        this.instance = new HashSet<>(instance.instance());
    }
    
    /***********************************************************/
    //业务使用的方法
    /***********************************************************/
    
    public HashSetO addAll(HashSetO set)
    {
        instance.addAll(set.instance());
        return this;
    }

    public Object[] toArray()
    {
        return instance.toArray();
    }

    public <T> T[] toArray(T[] a)
    {
        return instance.toArray(a);
    }
}
