/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.logging;

/**
 * 日志增加器接口<br><br>
 * 由子类实现各种不同的记录方式<br>
 * 1、ConsoleAppender，控制台记录器
 * 2、FileDailyAppender，文件每日循环记录器
 * 3、FileSizeAppender，文件大小循环记录
 * 4、EmptyAppender，空记录器，什么都不记录的一个适配记录器
 * 
 * @version v1.0.0 @author zouzhigang 2014-2-27 新建与整理
 * @version v1.5.0 @author zouzhigang 2019-4-23 从原Logger调整为LogAppender
 */
public interface LogAppender extends LogConstants
{
    /**
     * 增加日志到日志增加器中
     * 
     * @param level     日志级别
     * @param message   日志消息
     * @param throwable 日志异常
     */
    public void append(int level, String message, Throwable throwable);
}
