/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.transaction;

/**
 * 事务接口定义，包括提交、回滚、关闭以及判断是否已提交和已回滚
 *
 * @version v1.0.0 @author zouzhigang 2014-3-21 新建与整理
 */
public interface Transaction
{
    /** 获取事务服务编号 */
    public String getId();
    
    /** 开始事务 */
    public Transaction begin() throws Exception;
    
    /** 提交事务 */
    public void commit() throws Exception;
    
    /** 回滚事务 */
    public void rollback() throws Exception;
    
    /** 关闭事务 */
    public void close() throws Exception;
    
    /** 事务是否已提交 */
    public boolean isCommitted();
    
    /** 事务是否已回滚 */
    public boolean isRollbacked();
    
    /** 事务是否已关闭 */
    public boolean isClosed();
}
