/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.util;


/**
 * 关闭工具方法
 *
 * @version v1.0.0 @author zouzhigang 2019-5-20 新建与整理
 */
public class Closes
{
    
    /** 关闭并忽略异常 */
    public static void closeIgnoreException(AutoCloseable closeable)
    {
        if (closeable == null)
            return;
        
        try{closeable.close();}catch (Throwable e){}
    }
    
    /** 关闭多个忽略异常 */
    public static void closeIgnoreException(AutoCloseable... closeables)
    {
        for (AutoCloseable closeable : closeables)
        {
            closeIgnoreException(closeable);
        }
    }
}
