/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.util;

import java.util.Map;

import org.zhiqim.kernel.annotation.AnAlias;

/**
 * 哈希表工具类
 *
 * @version v1.0.0 @author zouzhigang 2014-3-21 新建与整理
 */
@AnAlias("Maps")
public class Maps
{
    /**
     * 给定一个哈希表和键，取值
     * 
     * @param map   哈希表
     * @param key   键
     * @return      键对应的值
     */
    public static Object get(Object map, Object key)
    {
        Asserts.as(map instanceof Map?null:"目标对象不是Map，方法不支持");
        
        return ((Map<?, ?>)map).get(key);
    }
    
    /**
     * 给定一个哈希表和键，取值
     * 
     * @param map   哈希表
     * @param key   键
     * @return      键对应的值
     */
    public static Object get(Map<?, ?> map, Object key)
    {
        return map.get(key);
    }
}
