/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.util.mutables;

/**
 * 定义双字段（字符串+字符串）可变对象，用于引用传递时直接修改值
 * 
 * @version v1.0.0 @author zouzhigang 2014-2-27 新建与整理
 */
public final class TStr
{
    public volatile String val;
    public volatile String str;
    
    /*******************************************************/
    //两个构造函数
    /*******************************************************/
    
    public TStr()
    {
    }
    
    public TStr(String val, String str)
    {
        this.val = val;
        this.str = str;
    }
    
    /*******************************************************/
    //设置值
    /*******************************************************/

    public TStr val(TStr value)
    {
        this.val = value.val;
        this.str = value.str;
        return this;
    }
    
    public TStr val(String val)
    {
        this.val = val;
        return this;
    }
    
    public TStr str(String str)
    {
        this.str = str;
        return this;
    }

    /*******************************************************/
    //获取值
    /*******************************************************/

    public String val()
    {
        return val;
    }
    
    public String str()
    {
        return str;
    }
    
    @Override
    public String toString()
    {
        return new StringBuilder("TStr:[")
            .append("val=").append(val).append(";")
            .append("str=").append(str).append("]")
            .toString();
    }
}

