/*
 * 版权所有 (C) 2015 知启蒙(ZHIQIM) 保留所有权利。[遇见知启蒙，邂逅框架梦]
 * 
 * https://zhiqim.org/project/zhiqim_framework/zhiqim_kernel.htm
 *
 * Zhiqim Kernel is licensed under Mulan PSL v2.
 * You can use this software according to the terms and conditions of the Mulan PSL v2.
 * You may obtain a copy of Mulan PSL v2 at:
 *          http://license.coscl.org.cn/MulanPSL2
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PSL v2 for more details.
 */
package org.zhiqim.kernel.util.streams;

import java.io.IOException;
import java.io.InputStream;

/**
 * 记录输入流长度的自定义输入流
 *
 * @version v1.0.0 @author zouzhigang 2017-6-14 新建与整理
 */
public class LengthInputStream extends InputStream
{
    private InputStream in;
    private long length;

    public LengthInputStream(InputStream in)
    {
        this.in = in;
    }
    
    
    public long length()
    {
        return length;
    }

    public int read() throws IOException
    {
        int c = in.read();
        if (c != -1)
            length++;
        
        return c;
    }
    
    public int read(byte[] b, int off, int len) throws IOException
    {
        int result = in.read(b, off, len);
        if (result != -1)
            length += len;
        
        return result;
    }
}
